      SUBROUTINE IAC2R(X,NX,Y,NY,FXY,NFX,NFY,LX,LY,MXA,FXA,MXB,FXB,
     1                 MYA,FYA,MYB,FYB,TX,TY,CXY,NCX,NCY,CY)
         INTEGER LX,LY,MXA,MXB,MYA,MYB,NCX,NCY,NFX,NFY,NX,NY
         REAL CXY,CY,FXA,FXB,FXY,FYA,FYB,TX,TY,X,Y
         DIMENSION CXY(NCX,NCY),CY(1),FXA(1),FXB(1),FXY(NFX,NFY),
     1             FYA(1),FYB(1),TX(1),TY(1),X(1),Y(1)
         EXTERNAL IAC1R1,IAC1R2,IAC1R3,IAC1R4
         INTEGER I,J,K,K0,K1,K2,K3,L,M,N
         REAL A,B,FA,FB,IAC1R1
         DIMENSION A(3),B(3)
         DATA K0/0/,K1/1/,K2/2/,K3/3/
       CALL IAC1R2(X,NX,MXA,TX)
       CALL IAC1R2(Y,NY,MYA,TY)
       DO 20 I = K1, NX
          J = K2 + I
          DO 10 K = K1, NY
             L = K2 + K
             CXY(J,L) = FXY(I,K)
   10     CONTINUE
   20  CONTINUE
       M = NX + K2
       N = NY + K2
       IF (MXA .GT. K2) GO TO 50
          CALL IAC1R3(TX,NX,CY,LX,MXA,MXB,A,B)
          DO 40 I = K3, N
             J = I - K2
             IF (MXA .GE. K1) FA = FXA(J)
             IF (MXB .GE. K1) FB = FXB(J)
             DO 30 J = K3, M
                CY(J) = CXY(J,I)
   30        CONTINUE
             CALL IAC1R4(TX,NX,CY,LX,MXA,FA,MXB,FB,A,B)
             CXY(K1,I) = CY(K1)
             CXY(K2,I) = CY(K2)
             K = M + K1
             CXY(K,I) = CY(K)
             K = K + K1
             CXY(K,I) = CY(K)
   40     CONTINUE
   50  CONTINUE
       IF (MYA .GT. K2) GO TO 110
          CALL IAC1R3(TY,NY,CY,LY,MYA,MYB,A,B)
          DO 70 I = K3, M
             J = I - K2
             IF (MYA .GE. K1) FA = FYA(J)
             IF (MYB .GE. K1) FB = FYB(J)
             DO 60 J = K3, N
                CY(J) = CXY(I,J)
   60        CONTINUE
             CALL IAC1R4(TY,NY,CY,LY,MYA,FA,MYB,FB,A,B)
             CXY(I,K1) = CY(K1)
             CXY(I,K2) = CY(K2)
             K = N + K1
             CXY(I,K) = CY(K)
             K = K + K1
             CXY(I,K) = CY(K)
   70     CONTINUE
          IF (MXA .GT. K2) GO TO 130
             CALL IAC1R3(TY,NY,CY,LY,K0,K0,A,B)
             DO 100 I = K1, K2
                K = K3 - I
                DO 80 J = K3, N
                   CY(J) = CXY(K,J)
   80           CONTINUE
                CALL IAC1R4(TY,NY,CY,LY,K0,FA,K0,FB,A,B)
                CXY(K,K1) = CY(K1)
                CXY(K,K2) = CY(K2)
                L = N + K1
                CXY(K,L) = CY(L)
                L = L + K1
                CXY(K,L) = CY(L)
                K = M + I
                DO 90 J = K3, N
                   CY(J) = CXY(K,J)
   90           CONTINUE
                CALL IAC1R4(TY,NY,CY,LY,K0,FA,K0,FB,A,B)
                CXY(K,K1) = CY(K1)
                CXY(K,K2) = CY(K2)
                L = N + K1
                CXY(K,L) = CY(L)
                L = L + K1
                CXY(K,L) = CY(L)
  100        CONTINUE
             M = M + K2
             N = N + K2
             GO TO 150
  110  CONTINUE
       K = K3
       IF (MXA .LT. K3) K = K - K2
       IF (MXA .LT. K3) M = M + K2
       DO 120 I = K, M
          J = N - K1
          CXY(I,K1) = CXY(I,J)
          J = J - K1
          CXY(I,K2) = CXY(I,J)
          J = K3 + K1
          L = N + K1
          CXY(I,L) = CXY(I,J)
          J = J + K1
          L = L + K1
          CXY(I,L) = CXY(I,J)
  120  CONTINUE
  130  CONTINUE
       N = N + K2
       IF (MXA .GT. K2) GO TO 150
          DO 140 I = K1, N
             J = M - K1
             CXY(K1,I) = CXY(J,I)
             J = J - K1
             CXY(K2,I) = CXY(J,I)
             L = K3 + K1
             J = M + K1
             CXY(J,I) = CXY(L,I)
             L = L + K1
             J = J + K1
             CXY(J,I) = CXY(L,I)
  140     CONTINUE
          M = M + K2
  150  CONTINUE
       L = N - K2
       DO 180 I = K1, M
          DO 160 J = K1, N
             CY(J) = CXY(I,J)
  160     CONTINUE
          DO 170 J = K1, L
             K = K1 + J
             CXY(I,J) = IAC1R1(TY,CY,LY,K)
  170     CONTINUE
  180  CONTINUE
       N = M - K2
       DO 210 I = K1, L
          DO 190 J = K1, M
             CY(J) = CXY(J,I)
  190     CONTINUE
          DO 200 J = K1, N
             K = K1 + J
             CXY(J,I) = IAC1R1(TX,CY,LX,K)
  200     CONTINUE
  210  CONTINUE
       RETURN
      END
